*portage-2.2.0_alpha51 (12 Aug 2011)
authorZac Medico <zmedico@gentoo.org>
Fri, 12 Aug 2011 12:51:48 +0000 (12:51 +0000)
committerZac Medico <zmedico@gentoo.org>
Fri, 12 Aug 2011 12:51:48 +0000 (12:51 +0000)
  12 Aug 2011; Zac Medico <zmedico@gentoo.org> +portage-2.2.0_alpha51.ebuild:
  2.2.0_alpha51 version bump. This includes all of the fixes in
  portage-2.1.10.11. Bug #210077 tracks all bugs fixed since portage-2.1.x.

*portage-2.1.10.11 (12 Aug 2011)

  12 Aug 2011; Zac Medico <zmedico@gentoo.org> +portage-2.1.10.11.ebuild:
  2.1.10.11 version bump. This fixes bug #323213 (clean up empty info dirs
  for packages like binutils), bug #377907 (remove "masked by: profile"
  support, which was legacy behavior according to PMS section 5.2.7), and
  bug #378403 (bail out early if $PORTAGE_TMPDIR/portage is a symlink and
  sandbox is enabled). This also includes a new repoman --if-modified option
  which can be used to limit checks to packages with uncommitted
  modifications, useful especially for category or repo-level commits.
  Bug #373933 tracks all bugs fixed since portage-2.1.10.3.

Package-Manager: portage-2.2.0_alpha51/cvs/Linux i686

sys-apps/portage/ChangeLog
sys-apps/portage/Manifest
sys-apps/portage/portage-2.1.10.11.ebuild [new file with mode: 0644]
sys-apps/portage/portage-2.2.0_alpha51.ebuild [new file with mode: 0644]

index 907f2996d55e52834bdf84970d6241c89f97cae7..aaaa1f0ecd5d43249f79dfaf12e435765cca7b23 100644 (file)
@@ -1,6 +1,24 @@
 # ChangeLog for sys-apps/portage
 # Copyright 1999-2011 Gentoo Foundation; Distributed under the GPL v2
-# $Header: /var/cvsroot/gentoo-x86/sys-apps/portage/ChangeLog,v 1.860 2011/08/08 09:28:47 zmedico Exp $
+# $Header: /var/cvsroot/gentoo-x86/sys-apps/portage/ChangeLog,v 1.861 2011/08/12 12:51:48 zmedico Exp $
+
+*portage-2.2.0_alpha51 (12 Aug 2011)
+
+  12 Aug 2011; Zac Medico <zmedico@gentoo.org> +portage-2.2.0_alpha51.ebuild:
+  2.2.0_alpha51 version bump. This includes all of the fixes in
+  portage-2.1.10.11. Bug #210077 tracks all bugs fixed since portage-2.1.x.
+
+*portage-2.1.10.11 (12 Aug 2011)
+
+  12 Aug 2011; Zac Medico <zmedico@gentoo.org> +portage-2.1.10.11.ebuild:
+  2.1.10.11 version bump. This fixes bug #323213 (clean up empty info dirs
+  for packages like binutils), bug #377907 (remove "masked by: profile"
+  support, which was legacy behavior according to PMS section 5.2.7), and
+  bug #378403 (bail out early if $PORTAGE_TMPDIR/portage is a symlink and
+  sandbox is enabled). This also includes a new repoman --if-modified option
+  which can be used to limit checks to packages with uncommitted
+  modifications, useful especially for category or repo-level commits.
+  Bug #373933 tracks all bugs fixed since portage-2.1.10.3.
 
   08 Aug 2011; Zac Medico <zmedico@gentoo.org> -portage-2.1.10.9.ebuild,
   -portage-2.2.0_alpha47.ebuild, -portage-2.2.0_alpha49.ebuild:
index 3375473e2a3e9e89257c61d653d83a913d7d237c..2169ea2ccf5de1477d2e004e83c45589d725df3a 100644 (file)
@@ -3,26 +3,30 @@ Hash: SHA1
 
 AUX README.RESCUE 137 RMD160 b8d015f266501fd1f57c91899c6815de9f9d5685 SHA1 cfc8fcf81921e265f40b47644916331e0b8f18b9 SHA256 69bea0c755eab59b6b4d90838b8551744f0b0c8eeac170b1cd13a71ee83f9ac4
 DIST portage-2.1.10.10.tar.bz2 846695 RMD160 085a4ac0ebed69999762ae7f54d3cb92ac6a7c69 SHA1 3053bc6912f66aa5d2313cb021024fe77516763b SHA256 66635eebdafa02b4e8125276d0beb17a58d732976b535d43b21aa7756790a2bb
+DIST portage-2.1.10.11.tar.bz2 849505 RMD160 ae1fae8df7e42978a988ae7f66c3bb335bfd31b4 SHA1 a0c35facd342cc32a4e713925809e72530b98ec9 SHA256 c9d47d2211fa5feec398bc155cf64ec911fb30eb11a32a9ae7ca38dbeb9b37de
 DIST portage-2.1.10.3.tar.bz2 833210 RMD160 76a2387b32fa2d879a19cfbdf60f906193fa5066 SHA1 0edb5bfc9005c9a9b39475c84c9f13a25a814987 SHA256 713a15b43c44ebe5a0ec1a880708ceb05773aad206383b39139b21bf36e1ded3
 DIST portage-2.1.6.13.patch.bz2 177383 RMD160 ef6388ca4a55a7defb319d54c9d80625cb8e12dc SHA1 5298feb6f881c25abdbde4a353d341fd36fdee51 SHA256 2cc897b6fa43b3329ef51f6304c064237be6bc326f1f0c221a19c0f96b69cd9c
 DIST portage-2.1.6.7.patch.bz2 50118 RMD160 cc0a322570829c8dec9aa4886deb5741f0efb489 SHA1 02021be38b0f829d45b342483834652a1985a952 SHA256 5f0605b51a24d23703330b040d2f7154322284db3e0cefa7499002ff1fa733c0
 DIST portage-2.1.6.tar.bz2 518771 RMD160 766ff4eb92497894f4c8678a9c4bc2756e4d9c63 SHA1 a28b191904296b551b22a7af83dacd1c336340a5 SHA256 b1c507445b3858449c861568f477e1cfab8b2326ded906b852c5193fb3839647
 DIST portage-2.1.9.42.tar.bz2 764537 RMD160 7bfef7fb167c986e36532416a0ed4b914f0a9809 SHA1 d5593b09781dae537198197adc3c1d7f7fb466f7 SHA256 1bd238065eca36aaae11607482ae43b20c64f338db7401a46c11ab56d6ff72ba
 DIST portage-2.2.0_alpha50.tar.bz2 847682 RMD160 904a61b0aa6bc8fdb2c71d7b5dddc0d799d783b3 SHA1 481fa00dbbf3d0e54a7fe305d0a844243c3c3563 SHA256 6cc55e26eb07328509cf59a8f8faa383f6fff9f4f2c2d725be3f463499c2974b
+DIST portage-2.2.0_alpha51.tar.bz2 848918 RMD160 84c771624d4f89d7017fd90d522a008e47b68345 SHA1 b8f09497e49af0e669014332511179c305fb4782 SHA256 3b695242c4a7f69d1b0863a82220ccd17512e018e404f279e2ddba7b7d29deb5
 DIST portage-man-pl-2.1.2.tar.bz2 53893 RMD160 46c3656b40bf4ad2530ab2b5fbc563708b86748c SHA1 c3151e0b330c589625830e54053fbc676b2c64de SHA256 960eaa7c6f3a2af44bdc665266a8e884628a562373cc477d301597ecc5ef961f
 EBUILD portage-2.1.10.10.ebuild 11177 RMD160 bbb804fd9651e5d65709ba99e5766d8a9320eec8 SHA1 193c2e19f0d5e9d8054bc194c5dd416a3cff5a59 SHA256 e30f5f65027249d60d2502b6b859675208c197457f8624945c65c5960341cbad
+EBUILD portage-2.1.10.11.ebuild 11177 RMD160 c77e5e319256ad86db6a4d5731eb627461e80d80 SHA1 7b82a2621f1521b1adefc7bba7edde6e48d5d06a SHA256 6ab80783ceeffc9e928e6e23c08f6e3e9024100d205fb5165cb1568a5f41c099
 EBUILD portage-2.1.10.3.ebuild 10221 RMD160 97396fdbcb6aff7705c2636f0fc829a83c1aa074 SHA1 eca88bafd3733c621473f03426558cf5a09ec176 SHA256 0a258d57a64921dbf2c9e21965a45212738d1758adf670b23670416d41f55888
 EBUILD portage-2.1.6.13.ebuild 10038 RMD160 a40e576c31f07f89387bda834607e62708b47e79 SHA1 ecbd0bae4ca5f340627f1dca792d137870be4d5e SHA256 c507d206aa08c39b387f464f1fe973d15b1b39baadd2a8feafc4867f8856e1a9
 EBUILD portage-2.1.6.7.ebuild 8689 RMD160 a04a6f87a6ded5b3c20413c79cc5d854f4083574 SHA1 1782ad24f77a56d2c8cbd88828d50451a1254f7e SHA256 a3f0e6639db74003108c933fcd4557bd4dccbfd913fc6fde7546dbec3987797a
 EBUILD portage-2.1.9.42.ebuild 10283 RMD160 60ac7fd535e83626095d2ef11466da8e8aa9b209 SHA1 b204bf62ad13b3c3d116fff53bc7a482eb89b7d8 SHA256 1b7968c34b0fc83aa1b388540a155340fdeb93df19de4515826af205fbcb9a3e
 EBUILD portage-2.2.0_alpha50.ebuild 12938 RMD160 06f7938f040317d5916817332a6a8c03e6227513 SHA1 d5f3b948362491a778259af8bf30d5822749f90a SHA256 d2d5982deb334fe81d7203a977dfd3cb1533e3b99c7b123c74458353602a4210
+EBUILD portage-2.2.0_alpha51.ebuild 12928 RMD160 72acaaa06c2d1c170b17ae9449ed9f9bceeb0735 SHA1 195fc5ef71c91f86ec3329833e56543d482c7b7d SHA256 486a6a78bae63337695a134af3f6ff6462a01613b1f1848663cd2ca79cd59292
 EBUILD portage-9999.ebuild 12214 RMD160 497e432fe756c9fda839cd2268a206e80e0ce1ca SHA1 9e9ef38845fa47767919d117c6f9e3c3b7924537 SHA256 ad0d82b6f9b62379595404695abebd73d0158fe257b2eedf117d9e49725ec8e7
-MISC ChangeLog 42796 RMD160 65aa4cca2eaafb61be52f6e4b6718f258992d2fe SHA1 557ed069a9fb72fc95b61aede80c8a07efa132f7 SHA256 e796f6050031b79799ec036af9ddc5791ffd89491e2a2608a173bd4abc9cec28
+MISC ChangeLog 43730 RMD160 e4aedadbf6bd65ff97284503bb2d76548dbc53d7 SHA1 5cd3f4651949e16a37c34ce10f8495586304cc45 SHA256 e8e4dc43f1d46808302a423a60924b9a571070de93db9dbadfa8a997e1a9ae4a
 MISC metadata.xml 806 RMD160 511095d817e35ffce10ea738cc401176c9346caa SHA1 d25de76c2eaaab4a4b84191e7f33893bee81370d SHA256 cc5f451325114cd24263899ca84010c02700de03e21fe413661178a9431962d9
 -----BEGIN PGP SIGNATURE-----
 Version: GnuPG v2.0.17 (GNU/Linux)
 
-iEYEARECAAYFAk4/rFUACgkQ/ejvha5XGaOs4gCg2cHCYH3A23QEQX4fFpAwN93N
-3PwAoKZjnCKEZDVa8DnZU00dHohejKTX
-=Uomf
+iEYEARECAAYFAk5FIesACgkQ/ejvha5XGaMJZQCfVtEw9MkyW1AmkqPtVnRad4CM
+GI0An1KdwXNKdWyPQki4sizNk9SnkRSL
+=bXhC
 -----END PGP SIGNATURE-----
diff --git a/sys-apps/portage/portage-2.1.10.11.ebuild b/sys-apps/portage/portage-2.1.10.11.ebuild
new file mode 100644 (file)
index 0000000..19be26a
--- /dev/null
@@ -0,0 +1,349 @@
+# Copyright 1999-2011 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: /var/cvsroot/gentoo-x86/sys-apps/portage/portage-2.1.10.11.ebuild,v 1.1 2011/08/12 12:51:48 zmedico Exp $
+
+# Require EAPI 2 since we now require at least python-2.6 (for python 3
+# syntax support) which also requires EAPI 2.
+EAPI=2
+inherit eutils multilib python
+
+DESCRIPTION="Portage is the package management and distribution system for Gentoo"
+HOMEPAGE="http://www.gentoo.org/proj/en/portage/index.xml"
+LICENSE="GPL-2"
+KEYWORDS="~alpha ~amd64 ~arm ~hppa ~ia64 ~m68k ~mips ~ppc ~ppc64 ~s390 ~sh ~sparc ~x86 ~sparc-fbsd ~x86-fbsd"
+SLOT="0"
+IUSE="build doc epydoc +ipc +less linguas_pl python2 python3 selinux"
+
+# Import of the io module in python-2.6 raises ImportError for the
+# thread module if threading is disabled.
+python_dep="python3? ( =dev-lang/python-3* )
+       !python2? ( !python3? (
+               build? ( || ( dev-lang/python:2.7 dev-lang/python:2.6[threads] ) )
+               !build? ( || ( dev-lang/python:2.7 dev-lang/python:2.6[threads] >=dev-lang/python-3 ) )
+       ) )
+       python2? ( !python3? ( || ( dev-lang/python:2.7 dev-lang/python:2.6[threads] ) ) )"
+
+# The pysqlite blocker is for bug #282760.
+DEPEND="${python_dep}
+       !build? ( >=sys-apps/sed-4.0.5 )
+       doc? ( app-text/xmlto ~app-text/docbook-xml-dtd-4.4 )
+       epydoc? ( >=dev-python/epydoc-2.0 !<=dev-python/pysqlite-2.4.1 )"
+
+RDEPEND="${python_dep}
+       !build? ( >=sys-apps/sed-4.0.5
+               >=app-shells/bash-3.2_p17
+               >=app-admin/eselect-1.2 )
+       elibc_FreeBSD? ( sys-freebsd/freebsd-bin )
+       elibc_glibc? ( >=sys-apps/sandbox-1.6 )
+       elibc_uclibc? ( >=sys-apps/sandbox-1.6 )
+       >=app-misc/pax-utils-0.1.17
+       selinux? ( || ( >=sys-libs/libselinux-2.0.94[python] <sys-libs/libselinux-2.0.94 ) )
+       !<app-shells/bash-3.2_p17
+       !<app-admin/logrotate-3.8.0"
+PDEPEND="
+       !build? (
+               less? ( sys-apps/less )
+               >=net-misc/rsync-2.6.4
+               userland_GNU? ( >=sys-apps/coreutils-6.4 )
+       )"
+# coreutils-6.4 rdep is for date format in emerge-webrsync #164532
+# NOTE: FEATURES=install-sources requires debugedit and rsync
+
+SRC_ARCHIVES="http://dev.gentoo.org/~zmedico/portage/archives"
+
+prefix_src_archives() {
+       local x y
+       for x in ${@}; do
+               for y in ${SRC_ARCHIVES}; do
+                       echo ${y}/${x}
+               done
+       done
+}
+
+PV_PL="2.1.2"
+PATCHVER_PL=""
+TARBALL_PV=$PV
+SRC_URI="mirror://gentoo/${PN}-${TARBALL_PV}.tar.bz2
+       $(prefix_src_archives ${PN}-${TARBALL_PV}.tar.bz2)
+       linguas_pl? ( mirror://gentoo/${PN}-man-pl-${PV_PL}.tar.bz2
+               $(prefix_src_archives ${PN}-man-pl-${PV_PL}.tar.bz2) )"
+
+PATCHVER=
+[[ $TARBALL_PV = $PV ]] || PATCHVER=$PV
+if [ -n "${PATCHVER}" ]; then
+       SRC_URI="${SRC_URI} mirror://gentoo/${PN}-${PATCHVER}.patch.bz2
+       $(prefix_src_archives ${PN}-${PATCHVER}.patch.bz2)"
+fi
+
+S="${WORKDIR}"/${PN}-${TARBALL_PV}
+S_PL="${WORKDIR}"/${PN}-${PV_PL}
+
+compatible_python_is_selected() {
+       [[ $(/usr/bin/python -c 'import sys ; sys.stdout.write(sys.hexversion >= 0x2060000 and "good" or "bad")') = good ]]
+}
+
+pkg_setup() {
+       # Bug #359731 - Die early if get_libdir fails.
+       [[ -z $(get_libdir) ]] && \
+               die "get_libdir returned an empty string"
+
+       if use python2 && use python3 ; then
+               ewarn "Both python2 and python3 USE flags are enabled, but only one"
+               ewarn "can be in the shebangs. Using python3."
+       fi
+       if ! use python2 && ! use python3 && ! compatible_python_is_selected ; then
+               ewarn "Attempting to select a compatible default python interpreter"
+               local x success=0
+               for x in /usr/bin/python2.* ; do
+                       x=${x#/usr/bin/python2.}
+                       if [[ $x -ge 6 ]] 2>/dev/null ; then
+                               eselect python set python2.$x
+                               if compatible_python_is_selected ; then
+                                       elog "Default python interpreter is now set to python-2.$x"
+                                       success=1
+                                       break
+                               fi
+                       fi
+               done
+               if [ $success != 1 ] ; then
+                       eerror "Unable to select a compatible default python interpreter!"
+                       die "This version of portage requires at least python-2.6 to be selected as the default python interpreter (see \`eselect python --help\`)."
+               fi
+       fi
+
+       if use python3; then
+               python_set_active_version 3
+       elif use python2; then
+               python_set_active_version 2
+       fi
+}
+
+src_prepare() {
+       if [ -n "${PATCHVER}" ] ; then
+               if [[ -L $S/bin/ebuild-helpers/portageq ]] ; then
+                       rm "$S/bin/ebuild-helpers/portageq" \
+                               || die "failed to remove portageq helper symlink"
+               fi
+               epatch "${WORKDIR}/${PN}-${PATCHVER}.patch"
+       fi
+       einfo "Setting portage.VERSION to ${PVR} ..."
+       sed -e "s/^VERSION=.*/VERSION=\"${PVR}\"/" -i pym/portage/__init__.py || \
+               die "Failed to patch portage.VERSION"
+       sed -e "1s/VERSION/${PVR}/" -i doc/fragment/version || \
+               die "Failed to patch VERSION in doc/fragment/version"
+       sed -e "1s/VERSION/${PVR}/" -i man/* || \
+               die "Failed to patch VERSION in man page headers"
+
+       if ! use ipc ; then
+               einfo "Disabling ipc..."
+               sed -e "s:_enable_ipc_daemon = True:_enable_ipc_daemon = False:" \
+                       -i pym/_emerge/AbstractEbuildProcess.py || \
+                       die "failed to patch AbstractEbuildProcess.py"
+       fi
+
+       if use python3; then
+               einfo "Converting shebangs for python3..."
+               python_convert_shebangs -r 3 .
+       elif use python2; then
+               einfo "Converting shebangs for python2..."
+               python_convert_shebangs -r 2 .
+       fi
+}
+
+src_compile() {
+       if use doc; then
+               cd "${S}"/doc
+               touch fragment/date
+               make xhtml xhtml-nochunks || die "failed to make docs"
+       fi
+
+       if use epydoc; then
+               einfo "Generating api docs"
+               mkdir "${WORKDIR}"/api
+               local my_modules epydoc_opts=""
+               my_modules="$(find "${S}/pym" -name "*.py" \
+                       | sed -e 's:/__init__.py$::' -e 's:\.py$::' -e "s:^${S}/pym/::" \
+                        -e 's:/:.:g' | sort)" || die "error listing modules"
+               # workaround for bug 282760
+               > "$S/pym/pysqlite2.py"
+               PYTHONPATH=${S}/pym:${PYTHONPATH:+:}${PYTHONPATH} \
+                       epydoc -o "${WORKDIR}"/api \
+                       -qqqqq --no-frames --show-imports $epydoc_opts \
+                       --name "${PN}" --url "${HOMEPAGE}" \
+                       ${my_modules} || die "epydoc failed"
+               rm "$S/pym/pysqlite2.py"
+       fi
+}
+
+src_test() {
+       # make files executable, in case they were created by patch
+       find bin -type f | xargs chmod +x
+       ./pym/portage/tests/runTests || die "test(s) failed"
+}
+
+src_install() {
+       local libdir=$(get_libdir)
+       local portage_base="/usr/${libdir}/portage"
+       local portage_share_config=/usr/share/portage/config
+
+       cd "${S}"/cnf
+       insinto /etc
+       doins etc-update.conf dispatch-conf.conf || die
+
+       insinto "$portage_share_config"
+       doins "$S/cnf/make.globals" || die
+       if [ -f "make.conf.${ARCH}".diff ]; then
+               patch make.conf "make.conf.${ARCH}".diff || \
+                       die "Failed to patch make.conf.example"
+               newins make.conf make.conf.example || die
+       else
+               eerror ""
+               eerror "Portage does not have an arch-specific configuration for this arch."
+               eerror "Please notify the arch maintainer about this issue. Using generic."
+               eerror ""
+               newins make.conf make.conf.example || die
+       fi
+
+       dosym ..${portage_share_config}/make.globals /etc/make.globals
+
+       insinto /etc/logrotate.d
+       doins "${S}"/cnf/logrotate.d/elog-save-summary || die
+
+       # BSD and OSX need a sed wrapper so that find/xargs work properly
+       if use userland_GNU; then
+               rm "${S}"/bin/ebuild-helpers/sed || die "Failed to remove sed wrapper"
+       fi
+
+       local x symlinks files
+
+       cd "$S" || die "cd failed"
+       for x in $(find bin -type d) ; do
+               exeinto $portage_base/$x || die "exeinto failed"
+               cd "$S"/$x || die "cd failed"
+               files=$(find . -mindepth 1 -maxdepth 1 -type f ! -type l)
+               if [ -n "$files" ] ; then
+                       doexe $files || die "doexe failed"
+               fi
+               symlinks=$(find . -mindepth 1 -maxdepth 1 -type l)
+               if [ -n "$symlinks" ] ; then
+                       cp -P $symlinks "$D$portage_base/$x" || die "cp failed"
+               fi
+       done
+
+       cd "$S" || die "cd failed"
+       for x in $(find pym/* -type d ! -path "pym/portage/tests*") ; do
+               insinto $portage_base/$x || die "insinto failed"
+               cd "$S"/$x || die "cd failed"
+               # __pycache__ directories contain no py files
+               [[ "*.py" != $(echo *.py) ]] || continue
+               doins *.py || die "doins failed"
+               symlinks=$(find . -mindepth 1 -maxdepth 1 -type l)
+               if [ -n "$symlinks" ] ; then
+                       cp -P $symlinks "$D$portage_base/$x" || die "cp failed"
+               fi
+       done
+
+       # We install some minimal tests for use as a preinst sanity check.
+       # These tests must be able to run without a full source tree and
+       # without relying on a previous portage instance being installed.
+       cd "$S" || die "cd failed"
+       exeinto $portage_base/pym/portage/tests || die
+       doexe pym/portage/tests/runTests || die
+       insinto $portage_base/pym/portage/tests || die
+       doins pym/portage/tests/*.py || die
+       insinto $portage_base/pym/portage/tests/lint || die
+       doins pym/portage/tests/lint/*.py || die
+       doins pym/portage/tests/lint/__test__ || die
+
+       # Symlinks to directories cause up/downgrade issues and the use of these
+       # modules outside of portage is probably negligible.
+       for x in "${D}${portage_base}/pym/"{cache,elog_modules} ; do
+               [ ! -L "${x}" ] && continue
+               die "symlink to directory will cause upgrade/downgrade issues: '${x}'"
+       done
+
+       doman "${S}"/man/*.[0-9]
+       if use linguas_pl; then
+               doman -i18n=pl "${S_PL}"/man/pl/*.[0-9]
+               doman -i18n=pl_PL.UTF-8 "${S_PL}"/man/pl_PL.UTF-8/*.[0-9]
+       fi
+
+       dodoc "${S}"/{ChangeLog,NEWS,RELEASE-NOTES}
+       use doc && dohtml -r "${S}"/doc/*
+       use epydoc && dohtml -r "${WORKDIR}"/api
+
+       dodir /usr/bin
+       for x in ebuild egencache emerge portageq quickpkg repoman ; do
+               dosym ../${libdir}/portage/bin/${x} /usr/bin/${x}
+       done
+
+       dodir /usr/sbin
+       local my_syms="archive-conf
+               dispatch-conf
+               emaint
+               emerge-webrsync
+               env-update
+               etc-update
+               fixpackages
+               regenworld"
+       local x
+       for x in ${my_syms}; do
+               dosym ../${libdir}/portage/bin/${x} /usr/sbin/${x}
+       done
+       dosym env-update /usr/sbin/update-env
+       dosym etc-update /usr/sbin/update-etc
+
+       dodir /etc/portage
+       keepdir /etc/portage
+}
+
+pkg_preinst() {
+       if [[ $ROOT == / ]] ; then
+               # Run some minimal tests as a sanity check.
+               local test_runner=$(find "$D" -name runTests)
+               if [[ -n $test_runner && -x $test_runner ]] ; then
+                       einfo "Running preinst sanity tests..."
+                       "$test_runner" || die "preinst sanity tests failed"
+               fi
+       fi
+
+       if ! use build && ! has_version dev-python/pycrypto && \
+               ! has_version '>=dev-lang/python-2.6[ssl]' ; then
+               ewarn "If you are an ebuild developer and you plan to commit ebuilds"
+               ewarn "with this system then please install dev-python/pycrypto or"
+               ewarn "enable the ssl USE flag for >=dev-lang/python-2.6 in order"
+               ewarn "to enable RMD160 hash support."
+               ewarn "See bug #198398 for more information."
+       fi
+       if [ -f "${ROOT}/etc/make.globals" ]; then
+               rm "${ROOT}/etc/make.globals"
+       fi
+
+       [[ -n $PORTDIR_OVERLAY ]] && has_version "<${CATEGORY}/${PN}-2.1.6.12"
+       REPO_LAYOUT_CONF_WARN=$?
+}
+
+pkg_postinst() {
+       # Compile all source files recursively. Any orphans
+       # will be identified and removed in postrm.
+       python_mod_optimize /usr/$(get_libdir)/portage/pym
+
+       if [ $REPO_LAYOUT_CONF_WARN = 0 ] ; then
+               ewarn
+               echo "If you want overlay eclasses to override eclasses from" \
+                       "other repos then see the portage(5) man page" \
+                       "for information about the new layout.conf and repos.conf" \
+                       "configuration files." \
+                       | fmt -w 75 | while read -r ; do ewarn "$REPLY" ; done
+               ewarn
+       fi
+
+       einfo
+       einfo "For help with using portage please consult the Gentoo Handbook"
+       einfo "at http://www.gentoo.org/doc/en/handbook/handbook-x86.xml?part=3"
+       einfo
+}
+
+pkg_postrm() {
+       python_mod_cleanup /usr/$(get_libdir)/portage/pym
+}
diff --git a/sys-apps/portage/portage-2.2.0_alpha51.ebuild b/sys-apps/portage/portage-2.2.0_alpha51.ebuild
new file mode 100644 (file)
index 0000000..af190f9
--- /dev/null
@@ -0,0 +1,404 @@
+# Copyright 1999-2011 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: /var/cvsroot/gentoo-x86/sys-apps/portage/portage-2.2.0_alpha51.ebuild,v 1.1 2011/08/12 12:51:48 zmedico Exp $
+
+# Require EAPI 2 since we now require at least python-2.6 (for python 3
+# syntax support) which also requires EAPI 2.
+EAPI=2
+inherit eutils multilib python
+
+DESCRIPTION="Portage is the package management and distribution system for Gentoo"
+HOMEPAGE="http://www.gentoo.org/proj/en/portage/index.xml"
+LICENSE="GPL-2"
+KEYWORDS="~sparc-fbsd ~x86-fbsd"
+SLOT="0"
+IUSE="build doc epydoc +ipc +less linguas_pl python2 python3 selinux"
+
+# Import of the io module in python-2.6 raises ImportError for the
+# thread module if threading is disabled.
+python_dep="python3? ( =dev-lang/python-3* )
+       !python2? ( !python3? (
+               build? ( || ( dev-lang/python:2.7 dev-lang/python:2.6[threads] ) )
+               !build? ( || ( dev-lang/python:2.7 dev-lang/python:2.6[threads] >=dev-lang/python-3 ) )
+       ) )
+       python2? ( !python3? ( || ( dev-lang/python:2.7 dev-lang/python:2.6[threads] ) ) )"
+
+# The pysqlite blocker is for bug #282760.
+DEPEND="${python_dep}
+       !build? ( >=sys-apps/sed-4.0.5 )
+       doc? ( app-text/xmlto ~app-text/docbook-xml-dtd-4.4 )
+       epydoc? ( >=dev-python/epydoc-2.0 !<=dev-python/pysqlite-2.4.1 )"
+# Require sandbox-2.2 for bug #288863.
+RDEPEND="${python_dep}
+       !build? ( >=sys-apps/sed-4.0.5
+               >=app-shells/bash-3.2_p17
+               >=app-admin/eselect-1.2 )
+       elibc_FreeBSD? ( sys-freebsd/freebsd-bin )
+       elibc_glibc? ( >=sys-apps/sandbox-2.2 )
+       elibc_uclibc? ( >=sys-apps/sandbox-2.2 )
+       >=app-misc/pax-utils-0.1.17
+       selinux? ( || ( >=sys-libs/libselinux-2.0.94[python] <sys-libs/libselinux-2.0.94 ) )
+       !<app-shells/bash-3.2_p17
+       !<app-admin/logrotate-3.8.0"
+PDEPEND="
+       !build? (
+               less? ( sys-apps/less )
+               >=net-misc/rsync-2.6.4
+               userland_GNU? ( >=sys-apps/coreutils-6.4 )
+       )"
+# coreutils-6.4 rdep is for date format in emerge-webrsync #164532
+# NOTE: FEATURES=install-sources requires debugedit and rsync
+
+SRC_ARCHIVES="http://dev.gentoo.org/~zmedico/portage/archives"
+
+prefix_src_archives() {
+       local x y
+       for x in ${@}; do
+               for y in ${SRC_ARCHIVES}; do
+                       echo ${y}/${x}
+               done
+       done
+}
+
+PV_PL="2.1.2"
+PATCHVER_PL=""
+TARBALL_PV=$PV
+SRC_URI="mirror://gentoo/${PN}-${TARBALL_PV}.tar.bz2
+       $(prefix_src_archives ${PN}-${TARBALL_PV}.tar.bz2)
+       linguas_pl? ( mirror://gentoo/${PN}-man-pl-${PV_PL}.tar.bz2
+               $(prefix_src_archives ${PN}-man-pl-${PV_PL}.tar.bz2) )"
+
+PATCHVER=
+[[ $TARBALL_PV = $PV ]] || PATCHVER=$PV
+if [ -n "${PATCHVER}" ]; then
+       SRC_URI="${SRC_URI} mirror://gentoo/${PN}-${PATCHVER}.patch.bz2
+       $(prefix_src_archives ${PN}-${PATCHVER}.patch.bz2)"
+fi
+
+S="${WORKDIR}"/${PN}-${TARBALL_PV}
+S_PL="${WORKDIR}"/${PN}-${PV_PL}
+
+compatible_python_is_selected() {
+       [[ $(/usr/bin/python -c 'import sys ; sys.stdout.write(sys.hexversion >= 0x2060000 and "good" or "bad")') = good ]]
+}
+
+pkg_setup() {
+       # Bug #359731 - Die early if get_libdir fails.
+       [[ -z $(get_libdir) ]] && \
+               die "get_libdir returned an empty string"
+
+       if use python2 && use python3 ; then
+               ewarn "Both python2 and python3 USE flags are enabled, but only one"
+               ewarn "can be in the shebangs. Using python3."
+       fi
+       if ! use python2 && ! use python3 && ! compatible_python_is_selected ; then
+               ewarn "Attempting to select a compatible default python interpreter"
+               local x success=0
+               for x in /usr/bin/python2.* ; do
+                       x=${x#/usr/bin/python2.}
+                       if [[ $x -ge 6 ]] 2>/dev/null ; then
+                               eselect python set python2.$x
+                               if compatible_python_is_selected ; then
+                                       elog "Default python interpreter is now set to python-2.$x"
+                                       success=1
+                                       break
+                               fi
+                       fi
+               done
+               if [ $success != 1 ] ; then
+                       eerror "Unable to select a compatible default python interpreter!"
+                       die "This version of portage requires at least python-2.6 to be selected as the default python interpreter (see \`eselect python --help\`)."
+               fi
+       fi
+
+       if use python3; then
+               python_set_active_version 3
+       elif use python2; then
+               python_set_active_version 2
+       fi
+}
+
+src_prepare() {
+       if [ -n "${PATCHVER}" ] ; then
+               if [[ -L $S/bin/ebuild-helpers/portageq ]] ; then
+                       rm "$S/bin/ebuild-helpers/portageq" \
+                               || die "failed to remove portageq helper symlink"
+               fi
+               epatch "${WORKDIR}/${PN}-${PATCHVER}.patch"
+       fi
+       einfo "Setting portage.VERSION to ${PVR} ..."
+       sed -e "s/^VERSION=.*/VERSION=\"${PVR}\"/" -i pym/portage/__init__.py || \
+               die "Failed to patch portage.VERSION"
+       sed -e "1s/VERSION/${PVR}/" -i doc/fragment/version || \
+               die "Failed to patch VERSION in doc/fragment/version"
+       sed -e "1s/VERSION/${PVR}/" -i man/* || \
+               die "Failed to patch VERSION in man page headers"
+
+       if ! use ipc ; then
+               einfo "Disabling ipc..."
+               sed -e "s:_enable_ipc_daemon = True:_enable_ipc_daemon = False:" \
+                       -i pym/_emerge/AbstractEbuildProcess.py || \
+                       die "failed to patch AbstractEbuildProcess.py"
+       fi
+
+       if use python3; then
+               einfo "Converting shebangs for python3..."
+               python_convert_shebangs -r 3 .
+       elif use python2; then
+               einfo "Converting shebangs for python2..."
+               python_convert_shebangs -r 2 .
+       fi
+}
+
+src_compile() {
+       if use doc; then
+               cd "${S}"/doc
+               touch fragment/date
+               make xhtml xhtml-nochunks || die "failed to make docs"
+       fi
+
+       if use epydoc; then
+               einfo "Generating api docs"
+               mkdir "${WORKDIR}"/api
+               local my_modules epydoc_opts=""
+               my_modules="$(find "${S}/pym" -name "*.py" \
+                       | sed -e 's:/__init__.py$::' -e 's:\.py$::' -e "s:^${S}/pym/::" \
+                        -e 's:/:.:g' | sort)" || die "error listing modules"
+               # workaround for bug 282760
+               > "$S/pym/pysqlite2.py"
+               PYTHONPATH=${S}/pym:${PYTHONPATH:+:}${PYTHONPATH} \
+                       epydoc -o "${WORKDIR}"/api \
+                       -qqqqq --no-frames --show-imports $epydoc_opts \
+                       --name "${PN}" --url "${HOMEPAGE}" \
+                       ${my_modules} || die "epydoc failed"
+               rm "$S/pym/pysqlite2.py"
+       fi
+}
+
+src_test() {
+       # make files executable, in case they were created by patch
+       find bin -type f | xargs chmod +x
+       ./pym/portage/tests/runTests || die "test(s) failed"
+}
+
+src_install() {
+       local libdir=$(get_libdir)
+       local portage_base="/usr/${libdir}/portage"
+       local portage_share_config=/usr/share/portage/config
+
+       cd "${S}"/cnf
+       insinto /etc
+       doins etc-update.conf dispatch-conf.conf || die
+
+       insinto "$portage_share_config/sets"
+       doins "$S"/cnf/sets/*.conf || die
+       insinto "$portage_share_config"
+       doins "$S/cnf/make.globals" || die
+       if [ -f "make.conf.${ARCH}".diff ]; then
+               patch make.conf "make.conf.${ARCH}".diff || \
+                       die "Failed to patch make.conf.example"
+               newins make.conf make.conf.example || die
+       else
+               eerror ""
+               eerror "Portage does not have an arch-specific configuration for this arch."
+               eerror "Please notify the arch maintainer about this issue. Using generic."
+               eerror ""
+               newins make.conf make.conf.example || die
+       fi
+
+       dosym ..${portage_share_config}/make.globals /etc/make.globals
+
+       insinto /etc/logrotate.d
+       doins "${S}"/cnf/logrotate.d/elog-save-summary || die
+
+       # BSD and OSX need a sed wrapper so that find/xargs work properly
+       if use userland_GNU; then
+               rm "${S}"/bin/ebuild-helpers/sed || die "Failed to remove sed wrapper"
+       fi
+
+       local x symlinks files
+
+       cd "$S" || die "cd failed"
+       for x in $(find bin -type d) ; do
+               exeinto $portage_base/$x || die "exeinto failed"
+               cd "$S"/$x || die "cd failed"
+               files=$(find . -mindepth 1 -maxdepth 1 -type f ! -type l)
+               if [ -n "$files" ] ; then
+                       doexe $files || die "doexe failed"
+               fi
+               symlinks=$(find . -mindepth 1 -maxdepth 1 -type l)
+               if [ -n "$symlinks" ] ; then
+                       cp -P $symlinks "$D$portage_base/$x" || die "cp failed"
+               fi
+       done
+
+       cd "$S" || die "cd failed"
+       for x in $(find pym/* -type d ! -path "pym/portage/tests*") ; do
+               insinto $portage_base/$x || die "insinto failed"
+               cd "$S"/$x || die "cd failed"
+               # __pycache__ directories contain no py files
+               [[ "*.py" != $(echo *.py) ]] || continue
+               doins *.py || die "doins failed"
+               symlinks=$(find . -mindepth 1 -maxdepth 1 -type l)
+               if [ -n "$symlinks" ] ; then
+                       cp -P $symlinks "$D$portage_base/$x" || die "cp failed"
+               fi
+       done
+
+       # We install some minimal tests for use as a preinst sanity check.
+       # These tests must be able to run without a full source tree and
+       # without relying on a previous portage instance being installed.
+       cd "$S" || die "cd failed"
+       exeinto $portage_base/pym/portage/tests || die
+       doexe pym/portage/tests/runTests || die
+       insinto $portage_base/pym/portage/tests || die
+       doins pym/portage/tests/*.py || die
+       insinto $portage_base/pym/portage/tests/lint || die
+       doins pym/portage/tests/lint/*.py || die
+       doins pym/portage/tests/lint/__test__ || die
+
+       # Symlinks to directories cause up/downgrade issues and the use of these
+       # modules outside of portage is probably negligible.
+       for x in "${D}${portage_base}/pym/"{cache,elog_modules} ; do
+               [ ! -L "${x}" ] && continue
+               die "symlink to directory will cause upgrade/downgrade issues: '${x}'"
+       done
+
+       doman "${S}"/man/*.[0-9]
+       if use linguas_pl; then
+               doman -i18n=pl "${S_PL}"/man/pl/*.[0-9]
+               doman -i18n=pl_PL.UTF-8 "${S_PL}"/man/pl_PL.UTF-8/*.[0-9]
+       fi
+
+       dodoc "${S}"/{ChangeLog,NEWS,RELEASE-NOTES}
+       use doc && dohtml -r "${S}"/doc/*
+       use epydoc && dohtml -r "${WORKDIR}"/api
+
+       dodir /usr/bin
+       for x in ebuild egencache emerge portageq quickpkg repoman ; do
+               dosym ../${libdir}/portage/bin/${x} /usr/bin/${x}
+       done
+
+       dodir /usr/sbin
+       local my_syms="archive-conf
+               dispatch-conf
+               emaint
+               emerge-webrsync
+               env-update
+               etc-update
+               fixpackages
+               regenworld"
+       local x
+       for x in ${my_syms}; do
+               dosym ../${libdir}/portage/bin/${x} /usr/sbin/${x}
+       done
+       dosym env-update /usr/sbin/update-env
+       dosym etc-update /usr/sbin/update-etc
+
+       dodir /etc/portage
+       keepdir /etc/portage
+}
+
+pkg_preinst() {
+       if [[ $ROOT == / ]] ; then
+               # Run some minimal tests as a sanity check.
+               local test_runner=$(find "$D" -name runTests)
+               if [[ -n $test_runner && -x $test_runner ]] ; then
+                       einfo "Running preinst sanity tests..."
+                       "$test_runner" || die "preinst sanity tests failed"
+               fi
+       fi
+
+       if ! use build && ! has_version dev-python/pycrypto && \
+               ! has_version '>=dev-lang/python-2.6[ssl]' ; then
+               ewarn "If you are an ebuild developer and you plan to commit ebuilds"
+               ewarn "with this system then please install dev-python/pycrypto or"
+               ewarn "enable the ssl USE flag for >=dev-lang/python-2.6 in order"
+               ewarn "to enable RMD160 hash support."
+               ewarn "See bug #198398 for more information."
+       fi
+       if [ -f "${ROOT}/etc/make.globals" ]; then
+               rm "${ROOT}/etc/make.globals"
+       fi
+
+       has_version "<${CATEGORY}/${PN}-2.2_alpha"
+       MINOR_UPGRADE=$?
+
+       has_version "<=${CATEGORY}/${PN}-2.2_pre5"
+       WORLD_MIGRATION_UPGRADE=$?
+
+       # If portage-2.1.6 is installed and the preserved_libs_registry exists,
+       # assume that the NEEDED.ELF.2 files have already been generated.
+       has_version "<=${CATEGORY}/${PN}-2.2_pre7" && \
+               ! ( [ -e "$ROOT"var/lib/portage/preserved_libs_registry ] && \
+               has_version ">=${CATEGORY}/${PN}-2.1.6_rc" )
+       NEEDED_REBUILD_UPGRADE=$?
+
+       [[ -n $PORTDIR_OVERLAY ]] && has_version "<${CATEGORY}/${PN}-2.1.6.12"
+       REPO_LAYOUT_CONF_WARN=$?
+}
+
+pkg_postinst() {
+       # Compile all source files recursively. Any orphans
+       # will be identified and removed in postrm.
+       python_mod_optimize /usr/$(get_libdir)/portage/pym
+
+       if [ $WORLD_MIGRATION_UPGRADE = 0 ] ; then
+               einfo "moving set references from the worldfile into world_sets"
+               cd "${ROOT}/var/lib/portage/"
+               grep "^@" world >> world_sets
+               sed -i -e '/^@/d' world
+       fi
+
+       if [ $NEEDED_REBUILD_UPGRADE = 0 ] ; then
+               einfo "rebuilding NEEDED.ELF.2 files"
+               for cpv in "${ROOT}/var/db/pkg"/*/*; do
+                       if [ -f "${cpv}/NEEDED" ]; then
+                               rm -f "${cpv}/NEEDED.ELF.2"
+                               while read line; do
+                                       filename=${line% *}
+                                       needed=${line#* }
+                                       needed=${needed//+/++}
+                                       needed=${needed//#/##}
+                                       needed=${needed//%/%%}
+                                       newline=$(scanelf -BF "%a;%F;%S;%r;${needed}" $filename)
+                                       newline=${newline//  -  }
+                                       echo "${newline:3}" >> "${cpv}/NEEDED.ELF.2"
+                               done < "${cpv}/NEEDED"
+                       fi
+               done
+       fi
+
+       if [ $REPO_LAYOUT_CONF_WARN = 0 ] ; then
+               ewarn
+               echo "If you want overlay eclasses to override eclasses from" \
+                       "other repos then see the portage(5) man page" \
+                       "for information about the new layout.conf and repos.conf" \
+                       "configuration files." \
+                       | fmt -w 75 | while read -r ; do ewarn "$REPLY" ; done
+               ewarn
+       fi
+
+       einfo
+       einfo "For help with using portage please consult the Gentoo Handbook"
+       einfo "at http://www.gentoo.org/doc/en/handbook/handbook-x86.xml?part=3"
+       einfo
+
+       if [ $MINOR_UPGRADE = 0 ] ; then
+               elog "If you're upgrading from a pre-2.2 version of portage you might"
+               elog "want to remerge world (emerge -e world) to take full advantage"
+               elog "of some of the new features in 2.2."
+               elog "This is not required however for portage to function properly."
+               elog
+       fi
+
+       if [ -z "${PV/*_alpha*}" ]; then
+               elog "If you always want to use the latest development version of portage"
+               elog "please read http://www.gentoo.org/proj/en/portage/doc/testing.xml"
+               elog
+       fi
+}
+
+pkg_postrm() {
+       python_mod_cleanup /usr/$(get_libdir)/portage/pym
+}